<?php
# +-------------- Asp I-DO SSL MailForm -------------------- +
#    PROGRAM NAME : ssl_send.php
#
#    (C)I-DO Communications ,Inc all right reserved.
#       hp : https://www.i-do.ne.jp/ 
# +--------------------------------------------------------------- +

/*
2020/08 UTF-8に変更
*/

error_reporting(0);

#--------------------------------------------
# クォート処理
#--------------------------------------------
function quote_smart($pgr) {
	$_pgr = array();
	foreach($pgr as $key=>$value) {
		if (is_array($value)) { 
			$_pgr[$key] = htmlentities($value, ENT_QUOTES, "UTF-8");
		} else {

			//aタグが含まれていたら404エラーを返す
			$tag_cnt = substr_count($value, "href=");
			$tag_cnt2 = substr_count($value, "href%3D");
			$tag_cnt = $tag_cnt + $tag_cnt2 + substr_count($value, "HREF=");
			if($tag_cnt > 0) { header("HTTP/1.0 404 Not Found"); exit; }

			//「magic_quotes_gpc=On」のときはエスケープ解除
			if(get_magic_quotes_gpc()) {
				$value = stripslashes($value);
			}
			$value = strip_tags($value);
			$value = str_replace("'", "’", $value);
			$value = str_replace('"', '”', $value);
			$_pgr[$key] = $value;
		} 
	}
	return $_pgr; 
} 

$_POST = quote_smart($_POST);
$_GET = quote_smart($_GET);
$_REQUEST = quote_smart($_REQUEST);

# ------------------------------------------
# 送信メッセージの組み立て
# ------------------------------------------
$date_now = date("Y/m/d H:i:j",mktime()); //送信日時(YYYY/MM/DD hh:mm:ss)

$m_body = "[送信日時] ".$date_now."\n";
$m_body .= "━━━━━━━━━━━━━━━━━━━━━━━━━━\n\n";

foreach($_POST as $key=>$var) {
	
	#------------------------------------------
	#サニタイズ処理
	#------------------------------------------
	//aタグが含まれていたら404エラーを返す
	$tag_cnt = substr_count($var, "href=");
	$tag_cnt2 = substr_count($var, "href%3D");
	$tag_cnt = $tag_cnt + $tag_cnt2 + substr_count($var, "HREF=");
	if($tag_cnt > 0) { header("HTTP/1.0 404 Not Found"); exit; }

	//「magic_quotes_gpc=On」のときはエスケープ解除
	if(get_magic_quotes_gpc()) {
		$var = stripslashes($var);
	}
	// XSS対策
	$var = strip_tags($var);
	$var = str_replace("'", "’", $var);
	$var = str_replace('"', '”', $var);


	switch ($key) {

		//宛先
		case "sendto":
			$send_to = $var;
			break;

		//終了画面のURL
		case "location":
			$location = $var;
			break;

		//件名
		case "subject":
			$subject = $var;
			break;

		//差出人E-Mailアドレス
		case "email":
			$from_to = $var;
			$m_body .= "[".$key."] ".$var."\n";
			break;

		//その他
		default:
			$var = stripslashes($var);
			$m_body .= "[".$key."] ".$var."\n";
			break;
	}
}

# ------------------------------------------
# メールの送信処理
# ------------------------------------------
//入力された宛先をメール関数用の宛先に変換する
//「名前 アドレス」→「JIS_MIMEにコード変換した名前 <アドレス>」
mb_language("japanese");
mb_internal_encoding("UTF-8");

$m_send_to = mailheaderaddr($send_to);
$m_from_to = mailheaderaddr($from_to);
if ($from_to=="" ) {
	$m_from_to = "anonymouse@m1.mail-do.com";
}

$return_path = '-f'.$m_from_to;

$header = "From:".$m_from_to."\n";
#メール送信プログラム名を付加
$header .= "X-Mailer: PHP/".phpversion()."\n";

$m_body = str_replace("\r\n","\n",$m_body);
$m_body = str_replace("\r","\n",$m_body);

$rcd = mb_send_mail($m_send_to, $subject, $m_body, $header,$return_path);

function mailheaderaddr($str) {
	$addrs = explode(",", $str);            //カンマで区切った文字列を配列に分けて入れる
	while (list(,$addr)=each($addrs)) {
		$addr = trim($addr);                  //宛先の前後の余分なスペースを取り除く
		$pos = strrpos($addr, " ");           //宛先の最後の半角スペースの位置
		if ($pos===false) {                   //半角スペースが無い場合
			$mailaddrs[] =  trim($addr);        //メールアドレスとして設定
		} else { //半角スペースがある場合
			$name = trim(substr($addr, 0, $pos));                       //前が名前
			$email = trim(substr($addr, $pos + 1));                     //後ろがメールアドレス
			$mailaddrs[] = mb_encode_mimeheader($name)." <".$email.">"; //宛先の組み立て
		}
	}
	return implode(", ", $mailaddrs); //複数宛先をカンマで区切った文字列にして返す
}

# ------------------------------------------
# 終了ページの表示
# ------------------------------------------
if ($location) {
	header("Location: $location");
} else {
?>
	<html>

	<head>
	<!--
	***********************************************************************************************************
	すべての記載事項、写真、グラフィックデザイン、プログラム、すべての商品名、サービスマーク、ロゴ等の著作権は、
	I-DO COMMUNICATIONS,INC. に帰属します。無断で複製、展示、貸与等の行為は、著作権法第2条第1項および同法第10条
	により禁止されています。				  Copyright(c) I-DO COMMUNICATIONS, INC. All rights reserved.
	***********************************************************************************************************
	// -->
	<meta http-equiv="Content-Language" content="ja">
	<meta http-equiv="Content-type" content="text/html; charset=UTF-8">
	<title>送信完了</title>
	<link rel="stylesheet" href="import.css" type="text/css" media="all">
	</head>

	<body>
	<div class="wrapper">

	<div class="comp">
		<div class="send-txt">送信完了</div>

		<div class="send-txt2">メッセージは正常に送信されました</div>
	</div>

	</body>

	</html>

<?php
}
?>
